/******************************************************************************
 * This file defines optional OpenClovis related component configuration.
 *****************************************************************************/

#include <clEoApi.h>

#define PRIORITY_MEDIUM CL_OSAL_THREAD_PRI_MEDIUM

/* Description of this component */

ClEoConfigT clEoConfig =
{
    "${safComponent_name}_EO",                           /* EO Name                                  */
    ${safComponent_eoProperties_threadPriority},    /* EO Thread Priority                       */
    ${safComponent_eoProperties_threadCount},       /* No of EO thread needed                   */
    ${safComponent_eoProperties_iocPortNumber},              /* Required Ioc Port                        */
    (CL_EO_USER_CLIENT_ID_START + 0), 
    ${safComponent_eoProperties_mainThreadUsagePolicy},   /* Thread Model                             */
    NULL,                       /* Application Initialize Callback          */
    NULL,                       /* Application Terminate Callback           */
    NULL,                       /* Application State Change Callback        */
    NULL,                       /* Application Health Check Callback        */
    NULL,
    CL_FALSE,
};

/*
 * Basic libraries used by this EO. The first 6 libraries are
 * mandatory, the others can be enabled or disabled by setting to
 * CL_TRUE or CL_FALSE.
 */

ClUint8T clEoBasicLibs[] =
{
    ${safComponent_eoProperties_aspLib_OSAL},      /* Lib: Operating System Adaptation Layer   */
    ${safComponent_eoProperties_aspLib_TIMER},     /* Lib: Timer                               */
    ${safComponent_eoProperties_aspLib_BUFFER},    /* Lib: Buffer Management                   */
    ${safComponent_eoProperties_aspLib_IOC},       /* Lib: Intelligent Object Communication    */
    ${safComponent_eoProperties_aspLib_RMD},       /* Lib: Remote Method Dispatch              */
    ${safComponent_eoProperties_aspLib_EO},        /* Lib: Execution Object                    */
    ${safComponent_eoProperties_aspLib_OM},        /* Lib: Object Management                   */
    ${safComponent_eoProperties_aspLib_HAL},       /* Lib: Hardware Adaptation Layer           */
    ${safComponent_eoProperties_aspLib_DBAL},      /* Lib: Database Adaptation Layer           */
};

/*
 * Client libraries used by this EO. All are optional and can be
 * enabled or disabled by setting to CL_TRUE or CL_FALSE.
 */

ClUint8T clEoClientLibs[] =
{
    ${safComponent_eoProperties_aspLib_COR},      /* Lib: Common Object Repository            */
    ${safComponent_eoProperties_aspLib_CM},       /* Lib: Chassis Management                  */
    ${safComponent_eoProperties_aspLib_NAME},     /* Lib: Name Service                        */
    ${safComponent_eoProperties_aspLib_LOG},      /* Lib: Log Service                         */
    ${safComponent_eoProperties_aspLib_TRACE},    /* Lib: Trace Service                       */
    ${safComponent_eoProperties_aspLib_DIAG},     /* Lib: Diagnostics                         */
    ${safComponent_eoProperties_aspLib_TXN},      /* Lib: Transaction Management              */
    ${safComponent_eoProperties_aspLib_MSO},      /* Lib: MSO Management                      */
    ${safComponent_eoProperties_aspLib_PROV},     /* Lib: Provisioning Management             */
    ${safComponent_eoProperties_aspLib_ALARM},    /* Lib: Alarm Management                    */
    ${safComponent_eoProperties_aspLib_DEBUG},    /* Lib: Debug Service                       */
    ${safComponent_eoProperties_aspLib_GMS},      /* Lib: Cluster/Group Membership Service    */
    ${safComponent_eoProperties_aspLib_PM}        /* Lib: PM Management                       */
};
